/*
 * Test_App.c
 *
 * Created: 23.05.2015 20:00:22
 *  Author: Gabriel
 */ 
#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

/*
1 - dreapta
2 - jos
3 - centru
4 - stanga
5 - sus 
*/

typedef struct led_type{
	uint8_t pos;
	volatile uint8_t *port;
} LED;

LED led[3][3];

typedef int bool;

#define stinge(l,c) ( *(led[l][c].port) &= ~(1 << led[l][c].pos) )
#define aprinde(l,c) (*(led[l][c].port) |= (1 << led[l][c].pos))
#define DREAPTA ((PINB & (1 << PB4)) == 0)
#define JOS		((PINB & (1 << PB3)) == 0)
#define CENTRU  ((PINB & (1 << PB2)) == 0)
#define STANGA  ((PINB & (1 << PB1)) == 0)
#define SUS     ((PINB & (1 << PB0)) == 0)
#define TRUE 1
#define FALSE 0

void stinge_delay(int l, int c) {
	stinge(l,c);
	_delay_ms(200);
}

void aprinde_delay(int l, int c) {
	aprinde(l,c);
	_delay_ms(200);
}

#define ORICARE (DREAPTA || STANGA || CENTRU || SUS || JOS)

uint8_t f[10][9] = { 1, 1, 1,
					 1, 0, 1,
					 1, 1, 1,
					 
					 1, 0, 1,
					 0, 1, 0,
					 1, 0, 1,
					 
					 1, 1, 1,
					 1, 1, 1,
					 0, 0, 0,
					 
					 0, 0, 0,
					 1, 1, 1,
					 1, 1, 1,
					 
					 1, 1, 1,
					 0, 0, 0,
					 1, 1, 1,
					 
					 1, 1, 1,
					 1, 1, 0,
					 1, 0, 0,
					 
					 1, 0, 0,
					 0, 1, 0,
					 0, 0, 1,
					 
					 0, 0, 1,
					 0, 1, 1,
					 1, 1, 1,
					 
					 0, 1, 1,
					 0, 1, 0,
					 1, 1, 0,
					 
					 1, 1, 0,
					 0, 1, 0,
					 0, 1, 1
					};
uint8_t try[3][3];

int compare(int z)
{
	int i,j,k = 0;
	for( i = 0; i < 3; i ++ )
		for( j = 0; j < 3; j ++ )
			if( try[i][j] != f[z][k++] )
				return FALSE;
				
	return TRUE;
}



void set_led() {
	DDRA = 0xFF;
	DDRC = 0xFF;
	PORTA = 0;
	PORTC = 0;
	
	led[0][0].pos = PA3;
	led[0][0].port = &PORTA;
	
	led[0][1].pos = PA4;
	led[0][1].port = &PORTA;
	
	led[0][2].pos = PA6;
	led[0][2].port = &PORTA;
	
	led[1][0].pos = PA1;
	led[1][0].port= &PORTA;
	
	led[1][1].pos = PA2;
	led[1][1].port = &PORTA;
	
	led[1][2].pos = PA5;
	led[1][2].port = &PORTA;
		
	led[2][0].pos = PC6;
	led[2][0].port = &PORTC;
	
	led[2][1].pos = PC5;
	led[2][1].port = &PORTC;
	
	led[2][2].pos = PA0;
	led[2][2].port = &PORTA;
	
	
}


void turn_off_all() {
	/* opresc LED - ul */
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);
	PORTD &= ~(1 << PD2);
}

void turn_on_all() {
	/* pornesc LED - ul */
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	PORTD |= (1 << PD2);
	
}

void test() {
	/* LED -ul PD0-2 - setez ca output */
	DDRD |= (1 << PD0) | (1 << PD1) | (1 << PD2);
	
	/* setez pinii PB1, PB2, PB3, PB4, PB5 ca intrare */
	PORTB &= ~(1 << PB1) & ~(1 << PB2) & ~(1 << PB3) & ~(1 << PB4) & ~(1 << PB5);
	
	/* activez pull-up pentru pinii PB1-PB5 */
	PORTB |= (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5);
	
	/* opresc LED - ul */
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);
	PORTD &= ~(1 << PD2);
	
	while(1)
	{
		//TODO:: Please write your application code
		//if (CENTRU || STANGA || JOS || DREAPTA || SUS) {
			PORTD |= (1 << PD0);
			PORTD |= (1 << PD1);
			PORTD |= (1 << PD2);
		//	} 
		//else {
		//}
	}
}

void sparkle(int n) {
	for (int i = 0; i < n; i++) {
		_delay_ms(180);
		turn_off_all();
		_delay_ms(180);
		turn_on_all();
	}
}

void loading(int n) {
	for (int i = 0; i < n; i++) {
		
	}
}

int level;

void set_level() {
	/* LED-ul PD0, PD1 si PD2 - setez ca output */
	DDRD |= (1 << PD0) | (1 << PD1) | (1 << PD2);
	
	/* opresc LED - urile */
	PORTD &= ~(1 << PD0);
	PORTD &= ~(1 << PD1);
	PORTD &= ~(1 << PD2);
	
	/* setez pinii PB1, PB2, PB3, PB4, PB5 ca intrare */
	DDRB &= ~(1 << PB0) & ~(1 << PB1) & ~(1 << PB2) & ~(1 << PB3) & ~(1 << PB4);
	
	/* activez pull-up pentru pinii PB1-PB5 */
	PORTB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4);
	
	level = 0;
	int state = 0;
	while (1) {
		if (state == 0)
			if (SUS) {
				level++;
				PORTD |= (1 << PD0);
				state = 1;
				_delay_ms(200);
			}
		if (state == 1) {
			if (SUS) {
				level++;
				PORTD |= (1 << PD1);
				state = 2;
				_delay_ms(200);
			}
			if (JOS) {
				level--;
				PORTD &= ~(1 << PD0);
				state = 0;
				_delay_ms(200);
			}
		}
		if (state == 2) {
			if (SUS) {
				level++;
				PORTD |= (1 << PD2);
				state = 3;
				_delay_ms(200);
			}
			if (JOS) {
				level--;
				PORTD &= ~(1 << PD1);
				state = 1;
				_delay_ms(200);
			}
		}
		if (state == 3) {
			if (JOS) {
				level--;
				PORTD &= ~(1 << PD2);
				state = 2;
				_delay_ms(200);
			}
		}
		if (state != 0) {
			if (CENTRU)
				break;	
		}
	}
	sparkle(10);
}

void figura( int i )
{
	switch (i)
	{
		case 0:
			aprinde(0,0);
			aprinde(0,1);
			aprinde(0,2);
			aprinde(1,0);
			aprinde(1,2);
			aprinde(2,0);
			aprinde(2,1);
			aprinde(2,2);
			break;
		
		case 1:
			aprinde(0,0);
			aprinde(0,2);
			aprinde(1,1);
			aprinde(2,0);
			aprinde(2,2);
			break;
		
		case 2:
			aprinde(0,0);
			aprinde(0,1);
			aprinde(0,2);
			aprinde(1,0);
			aprinde(1,1);
			aprinde(1,2);
			break;
		
		case 3:
			aprinde(2,0);
			aprinde(2,1);
			aprinde(2,2);
			aprinde(1,0);
			aprinde(1,1);
			aprinde(1,2);
			break;
		case 4:
			aprinde(0,0);
			aprinde(0,1);
			aprinde(0,2);
			aprinde(2,0);
			aprinde(2,1);
			aprinde(2,2);
			break;
		case 5:
			aprinde(0,0);
			aprinde(1,1);
			aprinde(0,1);
			aprinde(0,2);
			aprinde(1,0);
			aprinde(2,0);
			break;
		case 6:
			aprinde(0,0);
			aprinde(1,1);
			aprinde(2,2);
			break;
		case 7:
			aprinde(2,0);
			aprinde(1,1);
			aprinde(2,1);
			aprinde(0,2);
			aprinde(1,2);
			aprinde(2,2);
			break;
		case 8:
			aprinde(2,0);
			aprinde(1,1);
			aprinde(2,1);
			aprinde(0,2);
			aprinde(0,1);
			break;	
		case 9:
			aprinde(0,0);
			aprinde(0,1);
			aprinde(1,1);
			aprinde(2,2);
			aprinde(2,1);
		break;
		
	}

}

void clear_led()
{
	int i,j;
	for(i = 0 ; i < 3 ; i ++)
		for(j = 0; j < 3; j ++)
			stinge(i,j);
}

void turn_led() {
	int i,j;
	for(i = 0 ; i < 3 ; i ++)
		for(j = 0; j < 3; j ++)
		aprinde(i,j);
}

void lost_leds() {
	int i;
	for (i = 0; i < 3; i++)
		{
			turn_led();
			_delay_ms(100);
			clear_led();
			_delay_ms(100);			
		}
}

void winner() {
	int i;
	for (i = 0; i < 5; i++)
	{
		PORTA |= (1 << PA7);
		_delay_ms(200);
		PORTA &= ~(1 << PA7);
		_delay_ms(200);
	}
}

int main(void)
{
	while (1) {
	set_level();
	
	int *seq = (int*)malloc(sizeof(int) * level * 2);
	int seq_num = level * 2;

	// initializez secventa
	int i, j;
	srand(31);
	for (i = 0; i < seq_num; i++)
		seq[i] = rand() % 10;
		
	set_led();	
	
	// aprind secventa de matrici
	for( i = 0 ; i < seq_num ; i++)
	{
		figura(seq[i]);
		_delay_ms(4000);
		clear_led();
	}
	
	int count_figure = 0;
	bool all_good = TRUE;
	while (count_figure < seq_num) {
		// deseneaza figura
		
		// clear led-uri
		clear_led();
		_delay_ms(400);
		int i_cur, j_cur;
		i_cur = j_cur = 1;
		aprinde_delay(i_cur, j_cur);
		while (1) {
			if (SUS && JOS) {
				break;
			}
			else if (STANGA) {
				if (!try[i_cur][j_cur])
					stinge_delay(i_cur, j_cur);
				if (j_cur > 0)
					j_cur--;
				aprinde_delay(i_cur, j_cur);
			}	
			else if (DREAPTA) {
				if (!try[i_cur][j_cur])
					stinge_delay(i_cur, j_cur);
				if (j_cur < 2)
					j_cur++;
				aprinde_delay(i_cur, j_cur);
			}
			else if (JOS) {
				if (!try[i_cur][j_cur])
					stinge_delay(i_cur, j_cur);
				if (i_cur < 2)
					i_cur++;
				aprinde_delay(i_cur, j_cur);
			}
			else if (SUS) {
				if (!try[i_cur][j_cur])
					stinge_delay(i_cur, j_cur);
				if (i_cur > 0)
					i_cur--;
				aprinde_delay(i_cur, j_cur);
			}
			else if (CENTRU) {
				if (try[i_cur][j_cur] == 1) {
					try[i_cur][j_cur] = 0;
					stinge_delay(i_cur, j_cur);
				} else {
					try[i_cur][j_cur] = 1;
					aprinde_delay(i_cur, j_cur);					
				}
			}
		}
		
		// compara figura
		if (!compare(seq[count_figure]))
			{
				all_good = FALSE;
				lost_leds();
				break;
			}
		count_figure++;
		for (i = 0; i < 3; i++)
			for (j = 0; j < 3; j++)
				try[i][j] = 0;
	}
	clear_led();
	if (all_good)
		winner();	
	
	free(seq);
	while (!CENTRU);
	}
}